diff -ruNp ejudge-2.3.18/db/revisions ejudge/db/revisions
--- ejudge-2.3.18/db/revisions	2011-04-10 09:25:21.000000000 +0400
+++ ejudge/db/revisions	2011-07-11 09:02:02.796305506 +0400
@@ -6216,3 +6216,244 @@ run.c 6239 0 10053548
 super_html.c 6240 0 12260055
 super_html_3.c 6240 0 30771560
 super_html.c 6242 0 12097703
+misctext.h 6246 0 689392
+misctext.c 6246 0 3338994
+parsecfg.c 6246 0 3548610
+prepare_out.c 6246 0 7398283
+super_html_3.c 6246 0 30709637
+super_html_3.c 6247 0 30683591
+super_html.h 6251 0 1539480
+super_proto.h 6251 0 2395028
+super-serve.h 6251 0 631866
+uldb_plugin.h 6251 0 872825
+userlist_clnt.h 6251 0 991552
+super-serve.c 6251 0 14207246
+userlist-server.c 6251 0 24133296
+super_html.c 6251 0 12116011
+super_html_4.c 6251 0 18955815
+super_html_6.c 6251 0 456364
+uldb_plugin_xml.c 6251 0 8962741
+userlist_clnt/list_users_2.c 6249 0 209065
+plugins/mysql-userlist/uldb_mysql.c 6250 0 11878916
+super_html.h 6255 0 1549479
+uldb_plugin.h 6255 0 886375
+userlist_clnt.h 6255 0 1005115
+userlist-server.c 6255 0 24235899
+super_html_4.c 6255 0 19004749
+super_html_6.c 6255 0 732182
+uldb_plugin_xml.c 6255 0 9008525
+userlist_clnt/get_count.c 6254 0 193447
+plugins/mysql-userlist/uldb_mysql.c 6253 0 11973873
+super_html.h 6256 0 1559462
+userlist-server.c 6256 0 24237345
+super_html_4.c 6256 0 19004067
+super_html_6.c 6256 0 846625
+userlist_clnt/get_count.c 6257 0 193404
+plugins/mysql-userlist/uldb_mysql.c 6259 0 11986580
+plugins/mysql-userlist/uldb_mysql.c 6261 0 12218698
+userlist_clnt/get_count.c 6262 0 197361
+userlist_clnt/list_users_2.c 6262 0 213018
+super_html.h 6263 0 1579394
+super_proto.h 6263 0 2414165
+super-serve.h 6263 0 665207
+uldb_plugin.h 6263 0 912042
+userlist_clnt.h 6263 0 1008181
+userlist-server.c 6263 0 24535115
+super_html.c 6263 0 12173522
+super_html_4.c 6263 0 19040419
+super_html_6.c 6263 0 971750
+uldb_plugin_xml.c 6263 0 9307672
+userlist.c 6263 0 4739285
+super_html.h 6265 0 1603441
+super_proto.h 6265 0 2457713
+super_html.c 6265 0 12175045
+super_html_4.c 6265 0 19054832
+super_html_6.c 6265 0 3931406
+super_html.h 6267 0 1655834
+super_proto.h 6267 0 2479263
+super_html_4.c 6267 0 19087012
+super_html_6.c 6267 0 7010156
+super_html.h 6271 0 1687943
+super_proto.h 6271 0 2490346
+super_html_4.c 6271 0 19107494
+super_html_6.c 6271 0 9682141
+ejudge-setup.c 6273 0 10145660
+super_html.h 6282 0 1709914
+super_html_4.c 6282 0 19144860
+super_html_6.c 6282 0 11477018
+super_html.h 6284 0 1564459
+super_proto.h 6284 0 2490185
+userlist-server.c 6284 0 24862514
+super_html.c 6284 0 12174706
+super_html_4.c 6284 0 19707710
+super_html_6.c 6284 0 11859839
+ej_types.h 6286 0 234545
+meta_generic.h 6286 0 130035
+super_html.h 6286 0 1566199
+meta_generic.c 6286 0 295747
+super_html_4.c 6286 0 19711925
+super_html_6.c 6286 0 12117220
+super_html.h 6290 0 1569611
+uldb_plugin.h 6290 0 932594
+userlist_clnt.h 6290 0 1043669
+userlist-server.c 6290 0 26147918
+super_html_4.c 6290 0 19719920
+super_html_6.c 6290 0 12354820
+uldb_plugin_xml.c 6290 0 9370951
+userlist_clnt/create_user_2.c 6289 0 452792
+plugins/mysql-userlist/uldb_mysql.c 6288 0 12296065
+super_html_6.c 6292 0 12359925
+userlist-server.c 6296 0 26167917
+super_html_6.c 6296 0 12442034
+userlist_clnt/create_user_2.c 6296 0 452944
+super_html_6.c 6298 0 12699783
+super_html_6.c 6300 0 12707738
+ej_types.h 6302 0 237285
+super_html.h 6302 0 1576662
+super_html_4.c 6302 0 19738452
+super_html_6.c 6302 0 12938736
+super_html.h 6303 0 1584314
+super_html_4.c 6303 0 19756462
+super_html_6.c 6303 0 13605520
+super_html_6.c 6305 0 13605521
+super_html_6.c 6307 0 13606317
+super_html.h 6309 0 1589014
+super_html_4.c 6309 0 19767477
+super_html_6.c 6309 0 14310266
+super-serve.c 6311 0 14217760
+super_proto.h 6314 0 2502892
+uldb_plugin.h 6314 0 958745
+userlist_clnt.h 6316 0 1060550
+userlist-server.c 6314 0 26310172
+super_html_4.c 6314 0 19777805
+super_html_6.c 6314 0 15329443
+uldb_plugin_xml.c 6314 0 9555072
+userlist.c 6314 0 4741286
+userlist_clnt/get_prev_user_id.c 6315 0 200317
+plugins/mysql-userlist/uldb_mysql.c 6313 0 12588849
+super_html.h 6318 0 1590720
+super_proto.h 6318 0 2507622
+super_html_4.c 6318 0 19792289
+super_html_6.c 6318 0 16157338
+super_html_6.c 6321 0 16157333
+userlist_clnt/get_prev_user_id.c 6321 0 202522
+mischtml.h 6323 0 197562
+compile.c 6323 0 2352086
+ejudge-setup.c 6323 0 10145893
+job-server.c 6323 0 1322997
+new-server.c 6323 0 1827517
+super-serve.c 6323 0 14220052
+html_input_text.c 6323 0 200914
+super_html.c 6323 0 11721019
+super_html_4.c 6323 0 19792345
+super_html_6.c 6323 0 16255558
+lang_config_vis.h 6325 0 194875
+ejudge-configure-compilers.c 6325 0 1692425
+ejudge-setup.c 6325 0 10263154
+lang_config_vis.c 6325 0 2245746
+super_html.h 6326 0 1592596
+super_html_4.c 6326 0 19796160
+super_html_6.c 6326 0 16463191
+super_proto.h 6328 0 2511086
+super_html_6.c 6328 0 16466322
+super_html.h 6330 0 1593993
+super_proto.h 6330 0 2512578
+super_html_4.c 6330 0 19804416
+super_html_6.c 6330 0 16706012
+super_proto.h 6333 0 2513463
+userlist-server.c 6333 0 26310181
+super_html_6.c 6333 0 16448467
+uldb_plugin_xml.c 6333 0 9558039
+plugins/mysql-userlist/uldb_mysql.c 6332 0 12625041
+super_proto.h 6335 0 2517783
+super_html_6.c 6335 0 16885965
+super_html_6.c 6337 0 17225465
+super_html_6.c 6339 0 17585071
+html.h 6341 0 564770
+html.c 6341 0 14189613
+new_server_html.c 6341 0 39899424
+new_server_html_2.c 6341 0 16573488
+html.h 6343 0 575404
+mischtml.h 6343 0 221787
+html.c 6343 0 14399533
+html_hyperref.c 6343 0 212435
+new_server_html.c 6343 0 39974563
+new_server_html_2.c 6343 0 16579788
+prepare.c 6345 0 18782046
+sformat.c 6345 0 1817744
+misctext.h 6347 0 695511
+super_html.h 6347 0 1595322
+ejudge-setup.c 6347 0 10299757
+job-server.c 6347 0 1360702
+misctext.c 6347 0 3421863
+new_server_html_5.c 6347 0 9251098
+super_html_2.c 6347 0 4968404
+super_html_4.c 6347 0 19828577
+super_html_6.c 6347 0 17614743
+contests.h 6349 0 1201675
+contests.c 6349 0 4181588
+contest_tmpl.c 6349 0 945040
+super_proto.h 6351 0 2527479
+serve-control.c 6351 0 9423794
+super-serve.c 6351 0 14251132
+contests_2.c 6351 0 2045843
+super_html.c 6351 0 11773017
+super_html_2.c 6351 0 4991460
+super_html_3.c 6351 0 30688511
+super_html_4.c 6351 0 19844729
+new-server.h 6353 0 2301505
+new_server_html.c 6353 0 40002962
+new_server_html_2.c 6353 0 16581350
+new_server_html_3.c 6353 0 2781347
+new_server_html_5.c 6353 0 9260316
+bitset.h 6355 0 215575
+super_proto.h 6356 0 2588357
+bitset.c 6355 0 690834
+super_html_4.c 6356 0 19969809
+super_html_6.c 6356 0 18520483
+super_proto.h 6359 0 2590915
+super-serve.h 6359 0 668554
+super-serve.c 6359 0 14253386
+userlist-server.c 6359 0 26463581
+super_html_4.c 6359 0 20006342
+super_html_6.c 6359 0 19944503
+super_html_4.c 6361 0 20065630
+super_html_6.c 6361 0 21201248
+super_proto.h 6363 0 2603806
+userlist-server.c 6363 0 26621874
+super_html_4.c 6363 0 20102717
+super_html_6.c 6363 0 21855687
+super_html_6.c 6365 0 21862165
+userlist-server.c 6368 0 26622835
+unix/reuse_exec.c 6367 0 4420560
+serve_2.c 6368 0 9620332
+super_proto.h 6370 0 2606581
+super_html_4.c 6370 0 20107779
+super_html_6.c 6370 0 21972060
+super_proto.h 6372 0 2620181
+super_html_4.c 6372 0 20132010
+super_html_6.c 6372 0 22489789
+super_proto.h 6374 0 2627956
+super_html_4.c 6374 0 20146088
+super_html_6.c 6374 0 23233824
+super_proto.h 6377 0 2640864
+userlist-server.c 6377 0 26735216
+super_html_4.c 6377 0 20169910
+super_html_6.c 6377 0 23311933
+plugins/mysql-userlist/uldb_mysql.c 6376 0 12879277
+super_html.h 6379 0 1601098
+super_proto.h 6379 0 2644724
+super_html_4.c 6379 0 20216962
+super_html_6.c 6379 0 24425514
+uldb_plugin_xml.c 6379 0 9645022
+new-server.h 6381 0 2315370
+new-server-cmd.c 6381 0 2322130
+new_server_html.c 6381 0 40025683
+new_server_html_4.c 6381 0 5027241
+lang_config_vis.c 6387 0 2252111
+super_html.c 6390 0 11791816
+compile.c 6393 0 2392092
+new_server_html_2.c 6393 0 16583121
+serve_2.c 6393 0 9641561
+super_html_6.c 6398 0 24425640
+super_html_4.c 6401 0 20209972
diff -ruNp ejudge-2.3.18/db/versions ejudge/db/versions
--- ejudge-2.3.18/db/versions	2011-04-10 09:25:21.000000000 +0400
+++ ejudge/db/versions	2011-07-11 09:02:02.797305487 +0400
@@ -166,3 +166,4 @@
 5980 2.3 16 2010/08/17
 6033 2.3 17 2010/11/05
 6242 2.3 18 2011/04/10
+6393 2.3 19 2011/07/06
diff -ruNp ejudge-2.3.18/ej_types.h ejudge/ej_types.h
--- ejudge-2.3.18/ej_types.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/ej_types.h	2011-07-11 09:02:04.701270494 +0400
@@ -1,5 +1,5 @@
 /* -*- c -*- */
-/* $Id: ej_types.h 6172 2011-03-27 12:40:30Z cher $ */
+/* $Id: ej_types.h 6302 2011-05-04 04:22:17Z cher $ */
 #ifndef __EJ_TYPES_H__
 #define __EJ_TYPES_H__
 
@@ -34,6 +34,14 @@ typedef int ejintsize_t;
 typedef char **ejstrlist_t;
 typedef char **ejenvlist_t;
 
+/* for CGI param parser */
+typedef int ej_checkbox_t;
+typedef int ej_int_opt_0_t;
+typedef int ej_int_opt_1_t;
+typedef int ej_int_opt_m1_t;
+typedef unsigned char *ej_textbox_t;
+typedef unsigned char *ej_textbox_opt_t;
+
 /* privilege level */
 enum priv_level
 {
diff -ruNp ejudge-2.3.18/ejudge-configure-compilers.c ejudge/ejudge-configure-compilers.c
--- ejudge-2.3.18/ejudge-configure-compilers.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/ejudge-configure-compilers.c	2011-07-11 09:02:04.604272277 +0400
@@ -1,5 +1,5 @@
 /* -*- mode:c -*- */
-/* $Id: ejudge-configure-compilers.c 6135 2011-03-26 09:30:42Z cher $ */
+/* $Id: ejudge-configure-compilers.c 6325 2011-05-09 06:47:13Z cher $ */
 
 /* Copyright (C) 2008-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -345,7 +345,7 @@ visual_setup(unsigned char **keys, unsig
   script_in_dirs[1] = script_in_dir1;
   script_in_dirs[2] = 0;
   lang_configure_screen(script_dir, script_in_dirs,
-                        config_dir, tmp_work_dir, keys, vals, header);
+                        config_dir, tmp_work_dir, keys, vals, header, 0);
   while (lang_config_menu(script_dir, script_in_dirs, tmp_work_dir,
                           header, utf8_mode, &cur_item));
 
diff -ruNp ejudge-2.3.18/ejudge-setup.c ejudge/ejudge-setup.c
--- ejudge-2.3.18/ejudge-setup.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/ejudge-setup.c	2011-07-11 09:02:04.684270806 +0400
@@ -1,5 +1,5 @@
 /* -*- mode:c -*- */
-/* $Id: ejudge-setup.c 6224 2011-04-04 17:56:50Z cher $ */
+/* $Id: ejudge-setup.c 6347 2011-05-23 19:06:12Z cher $ */
 
 /* Copyright (C) 2004-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -1097,9 +1097,12 @@ is_valid_id_var(int idx)
   case ID_LINE_RETURN:
   case ID_LINE_SETTINGS:
     return 1;
+  case ID_LINE_EMAIL:
+    if (!is_valid_email_address(id_edit_items[idx].buf)) return 0;
+    if (id_edit_items[idx].buf[0]) return 1;
+    return 0;
   case ID_LINE_USER_ID:
   case ID_LINE_LOGIN:
-  case ID_LINE_EMAIL:
   case ID_LINE_NAME:
     if (id_edit_items[idx].buf[0]) return 1;
     return 0;
@@ -1119,6 +1122,21 @@ valid_id_str(int idx)
   return "!";
 }
 
+static void
+make_sha1_passwd(unsigned char *out_buf, const unsigned char *str)
+{
+  unsigned char buf2[64];
+  int len, j;
+
+  if (!str) str = "";
+  len = strlen(str);
+  memset(buf2, 0, sizeof(buf2));
+  sha_buffer(str, len, buf2);
+  for (j = 0; j < 20; j++) {
+    sprintf(out_buf + j * 2, "%02x", buf2[j]);
+  }
+}
+
 static int
 do_identity_menu(int *p_cur_item)
 {
@@ -1289,10 +1307,7 @@ do_identity_menu(int *p_cur_item)
 
         memset(config_password_txt, '*', j);
         config_password_txt[j] = 0;
-        sha_buffer(buf1, j, buf2);
-        for (j = 0; j < 20; j++) {
-          sprintf(config_password_sha1 + j * 2, "%02x", buf2[j]);
-        }
+        make_sha1_passwd(config_password_sha1, buf1);
         ncurses_msgbox("\\begin{center}\nNOTICE!\n\nThe password sha1 hash is %s!\n\\end{center}\n", config_password_sha1);
 
         cur_item = i;
@@ -1338,6 +1353,10 @@ do_identity_menu(int *p_cur_item)
           ncurses_errbox("\\begin{center}\nERROR!\n\nThe administrator e-mail contains invalid characters!\n\\end{center}\n");
           continue;
         }
+        if (!is_valid_email_address(buf1)) {
+          ncurses_errbox("\\begin{center}\nERROR!\n\nThe administrator e-mail is invalid!\n\\end{center}\n");
+          continue;
+        }
         snprintf(config_email, sizeof(config_email), "%s", buf1);
         break;
       case ID_LINE_NAME:
@@ -1541,7 +1560,7 @@ initialize_setting_var(int idx)
              system_group);
     break;
   case SET_LINE_DEFAULT_CLARDB_PLUGIN:
-#if CONF_HAS_MYSQL - 0 == 1
+#if 0 //CONF_HAS_MYSQL - 0 == 1
     snprintf(config_default_clardb_plugin, sizeof(config_default_clardb_plugin), "%s",
              "mysql");
 #else
@@ -1549,7 +1568,7 @@ initialize_setting_var(int idx)
 #endif
     break;
   case SET_LINE_DEFAULT_RUNDB_PLUGIN:
-#if CONF_HAS_MYSQL - 0 == 1
+#if 0 // CONF_HAS_MYSQL - 0 == 1
     snprintf(config_default_rundb_plugin, sizeof(config_default_rundb_plugin), "%s",
              "mysql");
 #else
@@ -1558,7 +1577,7 @@ initialize_setting_var(int idx)
     break;
   case SET_LINE_WORKDISK_FLAG:
     snprintf(config_workdisk_flag, sizeof(config_workdisk_flag),
-             "%s", "yes");
+             "%s", "no");
     break;
   case SET_LINE_INSTALL_FLAG:
     snprintf(config_install_flag, sizeof(config_install_flag),
@@ -1593,8 +1612,11 @@ is_valid_setting_var(int idx)
   case SET_LINE_DEFAULT_CLARDB_PLUGIN:
   case SET_LINE_DEFAULT_RUNDB_PLUGIN:
     return 1;
-  case SET_LINE_CHARSET:
   case SET_LINE_REG_EMAIL:
+    if (!is_valid_email_address(set_edit_items[idx].buf)) return 0;
+    if (set_edit_items[idx].buf[0]) return 1;
+    return 0;
+  case SET_LINE_CHARSET:
   case SET_LINE_REG_URL:
   case SET_LINE_SER_KEY:
   case SET_LINE_SERVER_NAME:
@@ -2260,6 +2282,7 @@ generate_serve_cfg(FILE *f)
   } else {
     fprintf(f, "charset = \"%s\"\n", cur->buf);
   }
+  fprintf(f, "advanced_layout\n");
 
   if (nbuiltin) {
     fprintf(f, "# The built-in variables are as follows\n");
@@ -2641,8 +2664,8 @@ generate_serve_cfg(FILE *f)
         "use_corr = 1\n"
         "corr_dir = \"%Ps\"\n"
         "real_time_limit = 5\n"
-        "check_cmd = \"check_%lPs\"\n"
-        "xml_file = \"%Ps.xml\"\n"
+        "check_cmd = \"check\"\n"
+        "xml_file = \"statement.xml\"\n"
         "max_vm_size = 64M\n"
         "max_stack_size = 64M\n"
         "max_file_size = 64M\n"
@@ -2852,24 +2875,12 @@ generate_contest_xml(FILE *f)
           "  <name>Test contest</name>\n"
           "  <name_en>Test contest</name_en>\n"
           "\n"
-          "  <register_access default=\"deny\">\n"
-          "    <ip allow=\"yes\">127.</ip>\n"
-          "  </register_access>\n"
-          "  <users_access default=\"deny\">\n"
-          "    <ip allow=\"yes\">127.</ip>\n"
-          "  </users_access>\n"
-          "  <team_access default=\"deny\">\n"
-          "    <ip allow=\"yes\">127.</ip>\n"
-          "  </team_access>\n"
-          "  <judge_access default=\"deny\">\n"
-          "    <ip allow=\"yes\">127.</ip>\n"
-          "  </judge_access>\n"
-          "  <master_access default=\"deny\">\n"
-          "    <ip allow=\"yes\">127.</ip>\n"
-          "  </master_access>\n"
-          "  <serve_control_access default=\"deny\">\n"
-          "    <ip allow=\"yes\">127.</ip>\n"
-          "  </serve_control_access>\n"
+          "  <register_access default=\"allow\" />\n"
+          "  <users_access default=\"allow\" />\n"
+          "  <team_access default=\"allow\" />\n"
+          "  <judge_access default=\"allow\" />\n"
+          "  <master_access default=\"allow\" />\n"
+          "  <serve_control_access default=\"allow\" />\n"
           "\n"
           "  <caps>\n"
           "    <cap login=\"%s\">MASTER_SET,</cap>\n"
@@ -3034,8 +3045,8 @@ generate_ejudge_xml(FILE *f)
   if (config_var_dir[0]) {
     fprintf(f, "  <var_dir>%s</var_dir>\n", config_var_dir);
     // FIXME: should make configurable paths?
-    fprintf(f, "  <userlist_log>userlist.log</userlist_log>\n");
-    fprintf(f, "  <super_serve_log>super_serve.log</super_serve_log>\n");
+    fprintf(f, "  <userlist_log>ej-users.log</userlist_log>\n");
+    fprintf(f, "  <super_serve_log>ej-super-server.log</super_serve_log>\n");
     //fprintf(f, "  <compile_log>%s</compile_log>\n");
   }
 
@@ -3230,7 +3241,7 @@ do_preview_menu(void)
   snprintf(script_dir, sizeof(script_dir), "%s/lang",
            tmp_work_dir);
   lang_configure_screen(script_dir, script_in_dirs, 0,
-                        tmp_work_dir, 0, 0, preview_header);
+                        tmp_work_dir, 0, 0, preview_header, 0);
 
   while (1) {
     mvwprintw(stdscr, 0, 0, "Ejudge %s configurator > File preview",
@@ -3409,77 +3420,8 @@ gen_check_retcode(FILE *f, const unsigne
 
 // solutions and tests for the sample contest 1
 const unsigned char b64_contest1_tgz[] =
-"begin-base64 664 contest-1.tar.gz\n"
-"H4sIAGOB+EcAA+1dW2/bRhb2a/grBtqkkBKZ4fCmupYd2IlRGNgGQZyiD93C\n"
-"IClaZkuRAkk5dooAuWC3BZrdxe7LAgss+rivbrbeppvE+QvUP9ozQ4qkYsdy\n"
-"UIlSrPO1Dsm5cEYcfmfOOTxDhr7bixzfC68vTAwSoNHQ2FaVlUZxO8AChRK6\n"
-"pOuarCxIlGq6tkC0yXUpRy+MjICQBWvXDs4qNyr/A0WYjb+x3bIssWuEY2+D\n"
-"DbCuq+8cf6pRGH9JUxuyQhUZxl9RJLpApLH35BTM+fh3A78dGB0S9jrLwh5c\n"
-"CaNOzDqxyCfE9b2240XLgmnDViCEBLbRcr2qUVsuHJnJEdRYIQa5Rkx+eD9w\n"
-"IhtyLci1vZYoTPuHIk5Fkf9Rd3b4r+jI/zKA/J9vFPn/tbFnWNuhJbKdMbYx\n"
-"iv8qlYH/GvBfA1EA6VRVGyryvww4na4fRISNuOj44tVloZgCt4YrblmG59nB\n"
-"siB0e6brWGTH8QyXWK4RhsTYNoVvgfBpFlzMCDZ7vtMiHcPxqltR4HhtYgTt\n"
-"8MuvaiTaDfz7IdnYt+wuu+2gJqtNSNoICckK8ez7g+Pq1kEY2R3R8RIpQ0Ag\n"
-"cREFvWGHBhQPRc/ejza9qJqWMU9LTE/k9yKxC12KmBxj0opnPxQezqmAKvLf\n"
-"BP3fmkAbI+d/XR/Yf2D3sflfbjD7D/k/efzO8Sy317JJM4xaIAB2VwWBcYyT\n"
-"l9G4xunNdIGcdyGQc6daueK24P9KnXwEOR8lTOLcSvL+4EFWzrHAjnqBR6Tl\n"
-"ueXaLKLI//a1a6LV7Y69jZH8b2T6vwxSgOn/VJWR/2Ug57/jhxGo9J1VoRey\n"
-"KdszOnbYNSwbJvXWci4UEoGQz8Og+jseWV0lRmE/SYfJljSbuVWAImDmMMR/\n"
-"6+txq/4cI/hPJZlm87+qM/+vouoN5H8ZOKn/n6blfwbEfw81P9fquUS5539j\n"
-"e84Dpt1HA/V+OKPK0tZ7Ozt2YLfu2kYrTdr0ur0oKZum5vZA7XSLIIzEwA7t\n"
-"aOvAi4z9gfYPqbbvboZbTttzdhzQX6LqjuGGdp5/3w9aN3eNIKwqSp3ImlbI\n"
-"2nWiRBYmBaQ6UeRa2mAUHKS/lpdlZgf/XdA0N0/ABrHbdiB2oabNDBIoFO4Z\n"
-"bnr6k5XM81Q605wBg4ZYRmTtkmpmaZH9WtbNtLK970RVOqgx12bQ3KIo/ztW\n"
-"KFrjd/+O1P8USWHyX29osq5KDa7/of+nHCS6XiIQQKDl4v4m2wOZf6ko61kG\n"
-"iCIm67/8ikv7mnAJylziQjiRW4os3mFSq3oT7irftUUmuX/veHaVSeykqHm+\n"
-"ooPkL5gzmadXvpUeFqzKSyixfiOK/O8eRLu+J3YPxtzGKP5L3P8jaZqk6rLC\n"
-"9b+GivwvBYy0wMhqYNzfdpi2BdQTzNMSuZqRMA8pd2FQ5H/QMw/EwBx7G5zi\n"
-"6ln8V7L4H1WR+PNf9P+WA8b/th2B4rfrd7qc+YVDoH5IDDHytx3Ge76D5L9I\n"
-"GPL/NBrijj/+u3yk/1eR0/lf03XK+U819P+UgsQhsHn73sanG3evqsSom3Ur\n"
-"dRPc3Vi7RapX61dr3MGSplokjfNIj7+4u3lvIy02qLlx+xaKiQ8CQ/b/gxDu\n"
-"8o4thlZnnG2M1P/VxuD5T0NjegJVVYz/LAfVlhN2XeOAVK+RKovoqqUb0PiZ\n"
-"C9YFq7smIJkvKoaf/0wr/kNeYAsEFFmS5UYS/6Fh/GcpOGf8x9BDlkH4R+vK\n"
-"u4I/MPbjQ8EQ/2co/lvG+b8UYPz3fGPI/7/bFeFv7G2M8v9RJYv/1GVNT/x/\n"
-"OP+XguYNwXXCiFQvGzUw7HeSuX3r3q3N23UCE3kF+JsWMN9ZIHk0cJmx/7JJ\n"
-"RFKB6X9ZuLGKpJ95DPHfDlyx6469jZH2fxb/qYAtoHH+q+j/KwXczw/kB2o3\n"
-"OalXgc9pojmUOETyZaT2xcDQ+o9udzrx39z/V1z/rygaPv8vBSfjv5kL4K1g\n"
-"78LqD4z2vlgo8v/AMI3QsURzzD6AkfO/JmX+f0Xj6z+pLiH/y8Dm7Tuf3yOV\n"
-"CjGEbNcU8md8d+5u3r5HLCTwBUXOf3Nq/n9ZUjP/P1P8uf8f9f9S8B7+f7Y0\n"
-"W6qTff4M4P6u49qkmj0KYA8C9mtkZYXQWrJsglxbYWVPPBUI8YnADOGU9z9E\n"
-"Jb//gYIAyN7/IMuUzf8aPv8vB+db/2Vsq7j8C5d/IS4civJ/z/QscW9C8d9n\n"
-"6X9UzdZ/0WT9h6Ki/C8Fn/mtHihyhils9cxkfVdNuOV0sufARjiQRgITZydX\n"
-"avGY8VOScxvy5DIuqyZseC0CTfJt0gmUPVPAUPzHDqgCgeGNOwj8/eO/VaWB\n"
-"6z9KAcZ/zzeK/N+Zpfgv9P+WAoz/mm8Mx38Gvuu3waL0x9rG6PhvZbD+W6WU\n"
-"r/+Q8f2/5eAKWby6SJKBZ7vCJ4vE8ZzIMVzngcHujCrz8NREgW0I5DLab3u9\n"
-"jmkH1bVafeh4HY5vEickayAI1uuJFKjehFTPrZNdw41EXEsyU2CuPLtje9EE\n"
-"PwDBQ7zO9f2HBnMAsO8/NKiM338oA4XxXxf3O+MP/lsY7f/XVR7/y4L+wPxj\n"
-"8X+yjvH/5aB5Awad7NlBCKJ+pUJFqUJsz/JbjtdeqfSincWPK+TGqtCEKcJ0\n"
-"7Q7T7bqG9Y3RtsEOrAQ90f6612rbYmh0uq69bfleZIdRhZVzWqzIOt+PDrq8\n"
-"Alxtr2UErcoqpDazu4+4htfuwUlX4JTbdz/n2VAgciLXXo3/ER/GP8eH/e/i\n"
-"Q7LevJ6kJiVadmgFDvdxs16uxv+CMv3H/SdQ5TWv9Aj2X8fH8SsSv4mP4eA4\n"
-"/l98ROLn8N8xK0HiX9Lz/63/BKr+NSn4OH4ZH0HyMZQ7hGpH8cv+M3Ymdvb+\n"
-"M9L/E0/6of9HAh17AeXhUBTif8LJ/svrHQ0yXsbH5zhn/ILALvTsFaS/7j/r\n"
-"fw8Hi3JKE5Jl/wTVX6bZg1xo9++8B/85V1Os+4/TVo+hi0+Kp4aivOdH7JK9\n"
-"iH8hqjT8C388x+n5NX0eH8Hl/x72jrIr23/EzgklD2EY+KiwzWu4moeFMYFW\n"
-"Th/I/g/xr4WBhCqQkg0kO+sbaOw73qfD+FfWM3aWp3BRX/Wfkv6f2XV+a8ia\n"
-"17vp3XR96HZiCdktyg/tfX6bh2nx9HA1dXs0+ctyVimRiULU5vXkcJDp9yKe\n"
-"KzWvp7tpm4WzZAfQAvQq4dwk4+gL8n9tWvJfy+I/B/M/yH8F5X8ZmLz8Xxuz\n"
-"/F+boPz/y0BK/cyk2ikS/mV8WD8hpF/ER8KiIr9DRkMu4ZnlizS4HEL870HH\n"
-"T/mZb9hkwdrh1wfOFT/n/QMZzS+SSOIf+f5PA/kOPWONw696xbsIV4fw7j1i\n"
-"s0FhvuNzR2EmEth1SWanY978U/7vE/ixT1mHeFNPeeNJE1kvXrBeZaN19K76\n"
-"Y5figvwOCa7MkgD/jWBkneS3/xjOY/8N4v8oZfo/+xAE2n9lIBn/tYneAee3\n"
-"//UGfxcEpSwkHMe/BAzGX5I00fAm8PLfhXPE/0vqW+MvSxra/6VAayilXGbE\n"
-"bCLnvzJF/mfv/1FUvv5XlvD9v+VAml3VFFECcv7LM8J/yvmv4PqfUqAh/+ca\n"
-"Of/pbPCfv/8H5n/8/lspkJH/c43i/N8yoom0wfl/1vv/uf2ffP9RlxL+4/P/\n"
-"ciALCkqAOUbR/p8e/7Wc/7LE+U9R/y8Fi6qgogCYX+T8V2dD/29Q1P9LxMdI\n"
-"/rlG0f6fhflf01P9H9d/lAIqUFyRMccozv8zYf/LDeR/iUD1f75RjP+ZKP/P\n"
-"0v+pnMf/yGry/A/f/1AKqKxQQVWXllAKzCUS/q/PQPwnf/+fDAWT+E+K8Z9l\n"
-"YDD+U43/ojQff01D/0+JWFrSNB2uPIr/+UTO/2nGf2Xvf1Y0JfX/4vt/SsHS\n"
-"ko7Un2Pk/J9m/JeS819O53+M/ygFFANA5xrF+X+S/h/1LP+vrOTrP7XU/4vx\n"
-"H6WASpIgw58Cfyr8LaI7eK5QtP+nxX+qFOx/KfH/ymj/lwKaQqAyx2ALO0sJ\n"
-"TuzkCVnK0tCWbVCKfBgo6v9Tm/+pfHL+x/WfpYAKLAJcFdAMQCAQCAQCgUAg\n"
-"EAgEAoFAIC4e/g/ULtleAMgAAA==\n"
-"====\n";
+#include "contest-1/contest-1.c"
+  ;
 
 static void
 generate_install_script(FILE *f)
@@ -3523,6 +3465,23 @@ generate_install_script(FILE *f)
   fprintf(f, "# Generated by ejudge-setup, version %s\n", compile_version);
   fprintf(f, "# Generation date: %s\n\n", date_buf);
 
+  fprintf(f,
+          "echo \"This script will ERASE the exising user database and contests!\"\n"
+          "echo \"Are you sure to proseed (yes/no)?\"\n"
+          "read confirm\n"
+          "if [ \"${confirm}\" != \"yes\" ];\n"
+          "then\n"
+          "  echo \"Operation is not confirmed\"\n"
+          "  exit 0\n"
+          "fi\n"
+          "uid=`id -u`\n"
+          "if [ \"${uid}\" != 0 ]\n"
+          "then\n"
+          "  echo \"This script must be run by ROOT user\" >&2\n"
+          "  exit 1\n"
+          "fi\n"
+          "");
+
   // create all the necessary directories
   fprintf(f, "# create all necessary directories\n");
   generate_dir_creation(f, &created_dirs, 0, config_ejudge_contests_home_dir);
@@ -3910,7 +3869,7 @@ preview_install_script(void)
   script_in_dirs[1] = 0;
   snprintf(script_dir, sizeof(script_dir), "%s/lang", tmp_work_dir);
   lang_configure_screen(script_dir, script_in_dirs, 0,
-                        tmp_work_dir, 0, 0, header);
+                        tmp_work_dir, 0, 0, header, 0);
 
   /*
   snprintf(script_dir, sizeof(script_dir), "%s/lang",
@@ -3928,7 +3887,7 @@ preview_install_script(void)
 }
 
 static void
-save_install_script(void)
+save_install_script(int batch_mode, const unsigned char *output_name)
 {
   FILE *f = 0;
   char *txt_ptr = 0, *p;
@@ -3948,7 +3907,7 @@ save_install_script(void)
   script_in_dirs[1] = 0;
   snprintf(script_dir, sizeof(script_dir), "%s/lang", tmp_work_dir);
   lang_configure_screen(script_dir, script_in_dirs, 0, tmp_work_dir,
-                        0, 0, header);
+                        0, 0, header, batch_mode);
 
   if (check_install_script_validity() < 0) return;
 
@@ -3956,11 +3915,18 @@ save_install_script(void)
   generate_install_script(f);
   close_memstream(f); f = 0;
 
-  snprintf(filepath, sizeof(filepath), "ejudge-install.sh");
-  j = ncurses_edit_string(LINES/2, COLS, "Setup script name",
-                          filepath, sizeof(filepath), utf8_mode);
-  if (j < 0) {
-    goto cleanup;
+  if (output_name && *output_name) {
+    snprintf(filepath, sizeof(filepath), "%s", output_name);
+  } else {
+    snprintf(filepath, sizeof(filepath), "ejudge-install.sh");
+  }
+
+  if (!batch_mode) {
+    j = ncurses_edit_string(LINES/2, COLS, "Setup script name",
+                            filepath, sizeof(filepath), utf8_mode);
+    if (j < 0) {
+      goto cleanup;
+    }
   }
 
   if ((fd = open(filepath, O_WRONLY | O_CREAT | O_TRUNC, 0770)) < 0) {
@@ -4062,7 +4028,7 @@ do_main_menu(void)
       preview_install_script();
       break;
     case 6:
-      save_install_script();
+      save_install_script(0, NULL);
       break;
     }
   }
@@ -4187,6 +4153,7 @@ main(int argc, char **argv)
   int answer = 1;
   int cur_arg = 1;
   const unsigned char *user = 0, *group = 0, *workdir = 0;
+  int batch_mode = 0;
 
   while (cur_arg < argc) {
     if (!strcmp(argv[cur_arg], "-u")) {
@@ -4201,6 +4168,9 @@ main(int argc, char **argv)
       if (cur_arg + 1 >= argc) arg_expected(argv[0]);
       workdir = argv[cur_arg + 1];
       cur_arg += 2;
+    } else if (!strcmp(argv[cur_arg], "-b")) {
+      batch_mode = 1;
+      cur_arg += 1;
     } else {
       break;
     }
@@ -4228,9 +4198,19 @@ main(int argc, char **argv)
            EJUDGE_SERVER_BIN_PATH);
   initialize_config_vars();
   initialize_setting_vars();
-  //answer = ncurses_yesno(0, initial_warning);
-  if (answer == 1) {
-    do_main_menu();
+
+  if (batch_mode) {
+    snprintf(config_user_id, sizeof(config_user_id), "%d", 1);
+    snprintf(config_login, sizeof(config_login), "%s", "ejudge");
+    snprintf(config_email, sizeof(config_email), "%s", "ejudge@localhost");
+    snprintf(config_name, sizeof(config_name), "%s", "ejudge administrator");
+    make_sha1_passwd(config_password_sha1, "ejudge");
+    save_install_script(1, "ejudge-install.sh");
+  } else {
+    //answer = ncurses_yesno(0, initial_warning);
+    if (answer == 1) {
+      do_main_menu();
+    }
   }
 
   ncurses_shutdown();
diff -ruNp ejudge-2.3.18/extra/ChangeLog ejudge/extra/ChangeLog
--- ejudge-2.3.18/extra/ChangeLog	2011-04-10 09:25:19.000000000 +0400
+++ ejudge/extra/ChangeLog	2011-07-11 09:02:01.872322476 +0400
@@ -1,3 +1,9 @@
+2011-05-02 (r6293) Alexander Chernov  <cher@ejudge.ru>
+
+	* Makefile.in: copyright notice is updated;
+	rules for compilation of explicitly 32- and 64-bit versions
+	of libdropcaps.so are added.
+
 2010-01-03 (r5602) Alexander Chernov  <cher@ejudge.ru>
 
 	* Makefile.in: copyright notice is updated;
diff -ruNp ejudge-2.3.18/extra/libdropcaps.c ejudge/extra/libdropcaps.c
--- ejudge-2.3.18/extra/libdropcaps.c	2011-04-10 09:25:19.000000000 +0400
+++ ejudge/extra/libdropcaps.c	2011-07-11 09:02:01.870322512 +0400
@@ -1,7 +1,7 @@
 /* -*- mode: c -*- */
-/* $Id: libdropcaps.c 5512 2008-12-27 19:32:44Z cher $ */
+/* $Id: libdropcaps.c 6383 2011-06-26 20:22:33Z cher $ */
 
-/* Copyright (C) 2003-2008 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2003-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -48,11 +48,13 @@ init(void)
   if (ptrace(0x4281, 0, 0, 0) >= 0) {
     // new secure exec interface
     /* if getppid works, CAP_SYS_OPERATIONS has no effect :-( */
+    /*
     if (dup(0) >= 0) {
       fprintf(stderr,
               "capexec: CAP_SYS_OPERATIONS is not supported on this system\n");
       _exit(6);
     }
+    */
     return;
   }
 
diff -ruNp ejudge-2.3.18/files.make ejudge/files.make
--- ejudge-2.3.18/files.make	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/files.make	2011-07-11 09:02:04.531273619 +0400
@@ -1,5 +1,5 @@
 # -*- Makefile -*-
-# $Id: files.make 6185 2011-03-27 15:16:29Z cher $
+# $Id: files.make 6356 2011-06-05 07:47:18Z cher $
 
 # Copyright (C) 2002-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -23,6 +23,7 @@ USERLIST_CLNT_CFILES=\
  userlist_clnt/copy_user_info.c\
  userlist_clnt/create_member.c\
  userlist_clnt/create_user.c\
+ userlist_clnt/create_user_2.c\
  userlist_clnt/delete_cookie.c\
  userlist_clnt/delete_field.c\
  userlist_clnt/delete_info.c\
@@ -33,16 +34,19 @@ USERLIST_CLNT_CFILES=\
  userlist_clnt/generate_team_passwd.c\
  userlist_clnt/get_contests.c\
  userlist_clnt/get_cookie.c\
+ userlist_clnt/get_count.c\
  userlist_clnt/get_database.c\
  userlist_clnt/get_fd.c\
  userlist_clnt/get_info.c\
  userlist_clnt/get_param.c\
+ userlist_clnt/get_prev_user_id.c\
  userlist_clnt/get_uid_by_pid.c\
  userlist_clnt/get_uid_by_pid_2.c\
  userlist_clnt/get_xml_by_text.c\
  userlist_clnt/import_csv_users.c\
  userlist_clnt/list_all_users.c\
  userlist_clnt/list_users.c\
+ userlist_clnt/list_users_2.c\
  userlist_clnt/login.c\
  userlist_clnt/logout.c\
  userlist_clnt/lookup_cookie.c\
@@ -116,6 +120,7 @@ COMMON_CFILES=\
  allowed_list.c\
  archive_paths.c\
  base64.c\
+ bitset.c\
  cgi.c\
  charsets.c\
  clarlog.c\
@@ -212,6 +217,7 @@ COMMON_CFILES=\
  super_html_3.c\
  super_html_4.c\
  super_html_5.c\
+ super_html_6.c\
  super_proto.c\
  sha.c\
  t3m_dir_listener.c\
@@ -462,6 +468,7 @@ CFILES=\
 HFILES=\
  archive_paths.h\
  base64.h\
+ bitset.h\
  cgi.h\
  charsets.h\
  clarlog.h\
